"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = classNames;
exports.beforeClass = beforeClass;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

var _utils = require("./utils");

function parseClassName(source, className) {
  if (!className) return source;
  if (typeof className === 'string') source.push(className);
  if (Array.isArray(className)) className.forEach(function (c) {
    return parseClassName(source, c);
  });else if ((0, _utils.isObject)(className)) Object.keys(className).forEach(function (c) {
    return className[c] && parseClassName(source, c);
  });else if ((0, _utils.isFunction)(className)) parseClassName(source, className);
  return source;
}

function classNames(className) {
  if (!className || typeof className === 'string') return className;
  return parseClassName([], className).join(' ');
}

function beforeClass(props) {
  props.className = classNames(props && props.className);
}