"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vuelikeInject = vuelikeInject;
Object.defineProperty(exports, "VUELIKE_METHODS", {
  enumerable: true,
  get: function get() {
    return _component.VUELIKE_METHODS;
  }
});
exports.default = exports.REACT_LIFECYCLE_HOOKS = void 0;

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

var _utils = require("./utils");

var _beforeCollect = _interopRequireDefault(require("./before-collect"));

var _beforeProps = _interopRequireDefault(require("./before-props"));

var _beforeAction = _interopRequireDefault(require("./before-action"));

var _component = _interopRequireWildcard(require("./component"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import React from 'react';
var REACT_LIFECYCLE_HOOKS = ['render', 'renderError', 'componentWillMount', 'componentDidMount', 'getSnapshotBeforeUpdate', 'componentDidUpdate', 'componentDidActivate', 'componentWillUnactivate', 'componentWillUnmount', 'componentDidCatch', 'componentEachJSXElement', 'componentEachRootJSXElement'];
exports.REACT_LIFECYCLE_HOOKS = REACT_LIFECYCLE_HOOKS;

function replaceVuelikeProto(target) {
  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var ret = {};
  var tp = target.prototype;
  var tm = Object.getOwnPropertyNames(tp);
  REACT_LIFECYCLE_HOOKS.forEach(function (key) {
    var tfn = tm.includes(key) ? tp[key] : null;
    if (!tfn && prefix && tm.includes(prefix + key)) tfn = tp[prefix + key];
    if (!tfn) return;
    var sfn = _component.default.prototype[key];
    if (sfn) tp[key] = sfn;else delete tp[key];
    ret[key] = tfn;
  });
  return ret;
}

function walkMixins(mixins, target) {
  mixins.forEach(function (mixin) {
    // eslint-disable-next-line
    if (mixin.props) target = (0, _beforeProps.default)(mixin, target);
    (0, _beforeAction.default)(mixin);
  });
}

function vuelikeInject(target) {
  if (target.vuelikeProto || !(0, _utils.isVuelikeComponentClass)(target)) return;
  var vuelikeProto = replaceVuelikeProto(target, 'UNSAFE_');
  (0, _utils.innumerable)(target, 'vuelikeProto', vuelikeProto);

  if ((0, _utils.hasOwnProperty)(target.prototype, 'shouldComponentUpdate')) {
    vuelikeProto.shouldComponentUpdate = target.prototype.shouldComponentUpdate;
    delete target.prototype.shouldComponentUpdate;
  }

  (0, _beforeCollect.default)(vuelikeProto, _component.default);
  var mixins = [target];
  if (target.mixins) Array.prototype.push.apply(mixins, target.mixins);
  walkMixins(mixins, target);
  return target; // const newTarget = React.forwardRef((props, ref) => {
  //   React.createElement(target, Object.assign({ $ref: ref }, props, props.children));
  // });
  // innumerable(newTarget, '__component', target);
  // return newTarget;
}

function vuelikeConstructor(target, props, children) {
  // vuelikeInject(target);
  // Object.keys(props).forEach(key => {
  //   if (!/^\$/.test(key)) return;
  //   Object.defineProperty(props, key, Object.assign(Object.getOwnPropertyDescriptor(props, key), { enumerable: false }));
  // });
  if (props.ref) {
    props.$ref = props.ref; // innumerable(props, '$ref', props.ref);

    delete props.ref;
  }
}

var _default = vuelikeConstructor;
exports.default = _default;