"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _react = _interopRequireDefault(require("react"));

var _utils = require("./utils");

var _vuelike = _interopRequireDefault(require("./vuelike"));

var _async = _interopRequireDefault(require("./async"));

var _observer = _interopRequireDefault(require("./observer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import collect from './collect';
var _createElement = _react.default.createElement;
var _forceUpdate = _react.default.Component.prototype.forceUpdate;
var builtInTags = {
  template: _react.default.Fragment,
  async: _async.default,
  observer: _observer.default
};

function createElementHook(Component, props) {
  var _this = this;

  for (var _len = arguments.length, children = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    children[_key - 2] = arguments[_key];
  }

  if (!Component) return _createElement.call.apply(_createElement, [this, Component, props].concat(children));
  children.forEach(function (c, i) {
    if (c instanceof Promise) children[i] = _createElement.call(_this, _async.default, {
      promise: c
    });
  });

  if (typeof Component === 'string') {
    var builtIn = builtInTags[Component];
    if (builtIn !== undefined) Component = builtIn;
  }

  if (!props) props = {};

  if (Component.vuelikeConstructor) {
    var newComponent = Component.vuelikeConstructor(Component, props, children, _react.default);
    if (newComponent !== undefined) Component = newComponent;
  }

  if (Component.beforeConstructor) {
    var _newComponent = Component.beforeConstructor(Component, props, children, _react.default);

    if (_newComponent !== undefined) Component = _newComponent;
  }

  return _createElement.call.apply(_createElement, [this, Component, props].concat(children));
}

function forceUpdateHook() {
  if (this && this.isVuelikeComponentInstance && this._checkActive) {
    return this._checkActive(_forceUpdate, arguments);
  }

  return _forceUpdate.apply(this, arguments);
}

(0, _utils.innumerable)(forceUpdateHook, _utils.VUELIKE_PREFIX, true);

function ReactHook() {
  if (_react.default[_utils.VUELIKE_PREFIX]) {
    if (_react.default[_utils.VUELIKE_PREFIX].build && _react.default[_utils.VUELIKE_PREFIX].build >= _vuelike.default.build) return;
  }

  _react.default.createElement = createElementHook;

  if (!_react.default.Component.prototype.forceUpdate[_utils.VUELIKE_PREFIX]) {
    _react.default.Component.prototype.forceUpdate = forceUpdateHook;
  }

  (0, _utils.innumerable)(_react.default, _utils.VUELIKE_PREFIX, _vuelike.default);
}

ReactHook.createElement = createElementHook;
var _default = ReactHook;
exports.default = _default;