"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.find-index");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.array.find");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

var _mobx = require("mobx");

var _config = _interopRequireDefault(require("./config"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var LIFECYCLE_HOOKS = ['componentWillMount', 'componentDidMount', 'getSnapshotBeforeUpdate', 'componentDidUpdate', 'componentDidActivate', 'componentWillUnactivate', 'componentWillUnmount', 'componentDidCatch'];

function normalizeComponentNames(comps, prefix) {
  var parentKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var COMP_REGX = /^[A-Z][A-Za-z]+/;
  var ret = {};
  Object.keys(comps).forEach(function (key) {
    if (!COMP_REGX.test(key)) return;
    var comp = comps[key];

    if (!comp) {
      console.warn("component [".concat(key, "] is not exist!"));
      return;
    }

    ret["".concat(prefix).concat(parentKey).concat(key)] = comp;
    Object.assign(ret, normalizeComponentNames(comp, prefix, "".concat(parentKey).concat(key)));
  });
  return ret;
}

function withVuelike(vuelike, component) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (component["".concat(_utils.VUELIKE_PREFIX, "Hoc")] === true) {
    (0, _utils.warn)("[withVuelike]You are trying to use 'withVuelike' on a component that already has 'withVuelike'");
    return component;
  }

  var isVuelikeClasses = (0, _utils.isVuelikeComponent)(component);

  if (!isVuelikeClasses) {
    var originComponent = component;

    if ((0, _utils.isReactComponent)(component)) {
      (0, _utils.innumerable)(component, 'beforeConstructor', function (target, props, children) {
        Object.assign(props, {
          $vuelike: vuelike
        }, vuelike.inherits);
        var originMethods = (0, _utils.replaceMethods)(target.prototype, LIFECYCLE_HOOKS.reduce(function (p, key) {
          p[key] = function () {
            var handlers = vuelike.listeners.component[key] || [];
            if (originComponent.isRoot) handlers = handlers.concat(vuelike.listeners.app[key] || []);

            var sr = vuelike._call(key, handlers, arguments);

            var tr = originMethods[key] && originMethods[key](arguments.concat(sr));
            return tr === undefined ? sr : tr;
          };
        }, {}), 'UNSAFE_');
      });
    } else if ((0, _utils.isFunctionComponent)(component)) {
      component = function VuelikeFunctionWrapper(props) {
        (0, _utils.innumerable)(props, '$vuelike', vuelike);
        Object.keys(vuelike.inherits).forEach(function (key) {
          return (0, _utils.innumerable)(props, key, vuelike.inherits[key]);
        });
        return originComponent(props);
      };
    } else if ((0, _utils.isForwardComponent)(component)) {
      var originRender = originComponent.render;

      originComponent.render = function (props) {
        (0, _utils.innumerable)(props, '$vuelike', vuelike);
        Object.keys(vuelike.inherits).forEach(function (key) {
          return (0, _utils.innumerable)(props, key, vuelike.inherits[key]);
        });
        return originRender.call(vuelike, props);
      };
    }

    component = (0, _utils.observer)(component);
  } // if (!isReactComponent(component)) {
  //   if (!component.vuelikeConstructor) {
  //     // eslint-disable-next-line no-proto
  //     const oldConstructor = component.__proto__;
  //     const VuelikeWrapper = function (props) {
  //       oldConstructor.apply(vuelike, arguments);
  //       vuelike._createInstance(props, component);
  //     };
  //     // VuelikeWrapper.prototype = Object.assign(target.prototype, {
  //     //   constructor: VuelikeWrapper
  //     // });
  //     component.prototype.prototype = VuelikeComponent.prototype;
  //     // eslint-disable-next-line no-proto
  //     component.__proto__ = VuelikeWrapper;
  //     innumerable(component, 'vuelikeConstructor', function (target, props, children) {
  //       return vuelikeConstructor(component, props, children);
  //     });
  //   }
  // } else {
  //   component = observer(component);
  // }


  var walkHocs = function walkHocs(component) {
    vuelike.hocs.forEach(function (hoc) {
      var newComponent = hoc(component, options);

      if (newComponent !== undefined) {
        component = newComponent;
      }
    });
    vuelike.plugins.forEach(function (_ref) {
      var pluginName = _ref.pluginName,
          plugin = _ref.plugin;
      if (!plugin.hoc) return;
      var newComponent = plugin.hoc(component, pluginName ? options[pluginName] || {} : options);

      if (newComponent !== undefined) {
        component = newComponent;
      }
    });
    return component;
  };

  component = walkHocs(component);
  (0, _utils.innumerable)(component, "".concat(_utils.VUELIKE_PREFIX, "Hoc"), true);
  return component;
}

var Vuelike = /*#__PURE__*/function () {
  function Vuelike() {
    var _this = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Vuelike);

    this.isVuelikeInstance = true;
    this.options = options;
    this.plugins = [];
    this.mixins = [];
    this.components = {};
    this.filters = {};
    this.directives = {};
    this.hocs = [];
    this.events = {
      component: {},
      app: {}
    };
    this.inherits = {};
    this.config = (0, _utils.mergeObject)({
      keyCodes: {},
      optionMergeStrategies: {}
    }, _config.default);
    (0, _utils.innumerable)(this, 'withVuelike', function (component) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return withVuelike(_this, component, options);
    });
  }

  _createClass(Vuelike, [{
    key: "getPlugin",
    value: function getPlugin(name) {
      var p = this.plugins.find(function (p) {
        var pluginName = p.pluginName || p.name;
        return pluginName === name;
      });
      return p ? p.plugin : null;
    }
  }, {
    key: "configure",
    value: function configure() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      (0, _utils.mergeObject)(this.config, options);

      if (this.config.enforceActions !== undefined) {
        (0, _mobx.configure)({
          enforceActions: this.config.enforceActions ? 'observed' : 'never'
        });
      }
    }
  }, {
    key: "use",
    value: function use(plugin) {
      var _this2 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (!plugin) return; // if (!plugin.name) throw new Error('[Vuelike.use]plugin \'name\' can not be empty!');

      var pluginName = plugin.pluginName || plugin.name;
      var install = (0, _utils.isFunction)(plugin) ? plugin : plugin.install ? plugin.install.bind(plugin) : null;
      if (!install) throw Error("[Vuelike.use]plugin ".concat(pluginName ? "'".concat(pluginName, "'") : '', " need has 'install' method!"));

      if (pluginName && this.getPlugin(pluginName)) {
        console.warn("[Vuelike.use]plugin ".concat(pluginName, " aleady be used!"));
        return;
      }

      var ret = install(this, options);

      var afterInstall = function afterInstall() {
        _this2.plugins.push({
          name: pluginName,
          plugin: plugin,
          options: options
        });

        return function () {
          var ret;

          var idx = _this2.plugins.find(function (p) {
            return p.plugin === plugin;
          });

          if (~idx) ret = _this2.plugins.splice(idx, 1);
          return ret;
        };
      };

      return ret instanceof Promise ? ret.then(function () {
        return afterInstall();
      }) : afterInstall();
    }
  }, {
    key: "mixin",
    value: function mixin(_mixin) {
      if (!_mixin) return;
      this.mixins.push(_mixin);
      return function () {
        var ret;
        var idx = this.mixins.find(function (v) {
          return v === _mixin;
        });
        if (~idx) ret = this.mixins.splice(idx, 1);
        return ret;
      };
    }
  }, {
    key: "hoc",
    value: function hoc(_hoc) {
      if (!_hoc) return;
      this.hocs.push(_hoc);
      return function () {
        var ret;
        var idx = this.hocs.find(function (v) {
          return v === _hoc;
        });
        if (~idx) ret = this.hocs.splice(idx, 1);
        return ret;
      };
    }
  }, {
    key: "component",
    value: function component(keyOrComponents) {
      var componentOrPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

      if ((0, _utils.isPlainObject)(keyOrComponents)) {
        Object.assign(this.components, normalizeComponentNames(keyOrComponents, componentOrPrefix));
        return keyOrComponents;
      }

      return this.components[keyOrComponents] = componentOrPrefix;
    }
  }, {
    key: "filter",
    value: function filter(keyOrFilters, _filter) {
      if ((0, _utils.isPlainObject)(keyOrFilters)) {
        (0, _utils.mergeObject)(this.filters, keyOrFilters);
        return keyOrFilters;
      }

      return this.filters[keyOrFilters] = _filter;
    }
  }, {
    key: "directive",
    value: function directive(keyOrDirectives, _directive) {
      if ((0, _utils.isPlainObject)(keyOrDirectives)) {
        Object.assign(this.directives, keyOrDirectives);
        return keyOrDirectives;
      }

      return this.directives[keyOrDirectives] = _directive;
    }
  }, {
    key: "_off",
    value: function _off(name, listener, events) {
      if (!name) throw new Error('[Vuelike]on name can not be empty!');
      var listeners = events[name];
      if (!listeners) return;
      var old;

      if (!listener) {
        old = events[name];
        events[name] = [];
        return old;
      }

      var idx = listeners.findIndex(function (v) {
        return v === listener;
      });
      if (~idx) old = listeners.splice(idx, 1);
      return old;
    }
  }, {
    key: "on",
    value: function on(name, listener, isComponent) {
      var _this3 = this;

      if (!name) throw new Error('[Vuelike]on name can not be empty!');
      if (!listener) throw new Error('[Vuelike]on listener can not be null!');
      name = (0, _utils.camelize)(name);
      var events = isComponent ? this.events.component : this.events.app;
      var listeners = events[name];
      if (!listeners) events[name] = listeners = [];
      var v = listeners.find(function (v) {
        return v === listener;
      });
      if (!v) listeners.push(listener);
      return function () {
        return _this3._off(name, listener, events);
      };
    }
  }, {
    key: "off",
    value: function off(name, listener, isComponent) {
      name = (0, _utils.camelize)(name);
      var events = isComponent ? this.events.component : this.events.app;
      return this._off(name, listener, events);
    }
  }, {
    key: "inherit",
    value: function inherit(keyOrInherits, value) {
      if (!keyOrInherits) return;

      if ((0, _utils.isPlainObject)(keyOrInherits)) {
        Object.assign(this.inherits, keyOrInherits);
        return keyOrInherits;
      }

      return this.inherits[keyOrInherits] = value;
    }
  }, {
    key: "createApp",
    value: function createApp(App) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var target = App;
      if ((0, _utils.isForwardComponent)(target) && target.__component) target = target.__component;

      if ((0, _utils.isVuelikeComponentClass)(target)) {
        if (target.isRoot && typeof target.isRoot === 'boolean' && !target.vuelike) {
          target.vuelike = this;
        }
      }

      return App;
    }
  }, {
    key: "_call",
    value: function _call(eventName, handlers, args) {
      try {
        if (!handlers) return;
        if ((0, _utils.isFunction)(handlers)) return handlers.call.apply(handlers, [this].concat(_toConsumableArray(args)));
        var ret;

        var _iterator = _createForOfIteratorHelper(handlers),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var handler = _step.value;
            ret = handler.apply(this, args.concat(ret));
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        return ret;
      } catch (e) {
        (0, _utils.handleError)(e, this, "_call:".concat(eventName));
        throw e;
      }
    }
  }, {
    key: "_resolveComp",
    value: function _resolveComp(compName) {
      var comp = this.components[compName];
      if (!_utils.isProduction && !comp) (0, _utils.warn)("can not resolve component '".concat(compName, "'!"), this);
      return comp || compName;
    }
  }, {
    key: "_resolveAction",
    value: function _resolveAction(handler) {
      if (!handler) return handler;
      return (0, _mobx.action)(handler);
    }
  }, {
    key: "_resolveFilter",
    value: function _resolveFilter(filter, filterName) {
      if (!this.filters) return '';

      try {
        return filter();
      } catch (e) {
        (0, _utils.handleError)(e, this, "filter:".concat(filterName));
        return '';
      }
    }
  }]);

  return Vuelike;
}();

(0, _utils.innumerable)(Vuelike, _utils.VUELIKE_CLASS, true);
var ALIAS_METHODS = {
  _resolveComp: '_c',
  _resolveAction: '_a',
  _resolveFilter: '_f'
};
Object.keys(ALIAS_METHODS).forEach(function (key) {
  return (0, _utils.innumerable)(Vuelike.prototype, ALIAS_METHODS[key], Vuelike.prototype[key]);
});
var _default = Vuelike;
exports.default = _default;